# sdr_beta.s - beta loader (DOS)
# Copyright (C) 2000 Tachibana Eriko
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
# USA


* Include File -------------------------------- *

		.include	macro.mac
		.include	doscall.mac


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

_dos_beta::
		PUSH	d3-d7/a3-a6
		movem.l	(9*4+4,sp),d5/d6/d7/a5
loop_f:
		subq.l	#1,d6			;frame_num
		bcs	return

		move.l	d7,-(sp)		;frame_size
		pea	(a5)			;buf
		move	d5,-(sp)		;fd
		DOS	_READ
		lea	(10,sp),sp
		cmp.l	d7,d0
		bne	return

		lea	(a5),a0
		movea.l	(a0)+,a2		;GVRAM Address
		move	(a0)+,d1		;X length
		move	(a0)+,d2		;Y length
		move.l	(a0)+,d3		;X offset
		move.l	(a0)+,d4		;Y offset

		lsr	#1,d1
		subq	#1,d1
		subq	#1,d2
loop_y:
		lea	(a2),a1
		move	d1,d0
loop_x:
		move.l	(a0)+,(a1)+
		dbra	d0,loop_x

		adda.l	d3,a2
		dbra	d2,loop_y

		move	#1,-(sp)
		DOS	_KEYCTRL
		addq.l	#2,sp
		tst.l	d0
		beq	loop_f
		clr	-(sp)
		DOS	_KEYCTRL
		addq.l	#2,sp
		cmpi.b	#$1b,d0
		bne	loop_f

		move	#2,-(sp)
		DOS	_KEYCTRL
		addq.l	#2,sp
		moveq	#1,d1
		and.l	d1,d0
		bra	@f
return:
		moveq	#0,d0
@@:
		POP	d3-d7/a3-a6
		rts


		.end

* End of File --------------------------------- *
