/* dos_yat.c - YAT loader (DOS)
 * Copyright (C) 2000 Tachibana Eriko
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#include <sys/dos.h>

#include "isd_header.h"


/* External functions */
extern void yat_sub (char* buf);


/* Function */
int
dos_yat (int fd, int frame_num, int* tbl_ptr, char* buf)
{
  int* tbl_end = tbl_ptr + frame_num;

  while (tbl_ptr < tbl_end)
    {
      int frame_size = *tbl_ptr++;

      if (_dos_read (fd, buf, frame_size) != frame_size)
	break;

      YatDecode (buf);

      if (_dos_k_keysns () && _dos_k_keyinp () == 0x1b)
	return _dos_k_sftsns () & 1;	/* ESC ĂI */
    }

  return 0;
}

/* EOF */
